-----------------------------------------------------------------------------------------------
-- Client Lua Script for NCT
-- GPLv3
-----------------------------------------------------------------------------------------------
 
require "Apollo"
require "Window"
require "Unit"
require "Spell"
require "GameLib"
require "ChatSystemLib"
require "ChatChannelLib"
require "CombatFloater"
require "GroupLib"
require "math"
 
-----------------------------------------------------------------------------------------------
-- NCT Module Definition
-----------------------------------------------------------------------------------------------
local NCT = {} 

--[[FromLeftOfPlayer = {[0] = {tPos = {x=(SSX/2)-100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=0,y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = (SSX/2)-100, y1 = 0, y2 = SSY,}},
	FromRightOfPlayer = {[0] = {tPos = {x=(SSX/2)+100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}, 
						[1] = {nTimeToPos = 1000, tPos = {x=0,y=0}, tOffset = {x=0,y=0}, tRand = {x1 = (SSX/2)+100, x2 = SSX, y1 = 0, y2 = SSY,}},
	ToLeftOfPlayer = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = (SSX/2)-100, y1 = 0, y2 = SSY}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	ToRightOfPlayer = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = (SSX/2)+100, x2 = SSX, y1 = 0, y2 = SSY}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)+100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	Not Sauce's DD = {[0] = {tPos = {x=(SSX/2)-300, y=(SSY/2)+75}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-350, y=(SSY/2)+175}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	Sauce's DD = {[0] = {tPos = {x=(SSX/2)-150, y=(SSY/2)-50}, tOffset = {x=0,y=15}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-200, y=(SSY/2)-400}, tOffset = {x=0,y=15}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	Sauce's DR = {[0] = {tPos = {x=(SSX/2)+200, y=(SSY/2)+75}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)+250, y=(SSY/2)+175}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	Sauce's ID = {[0] = {tPos = {x=(SSX/2), y=(SSY/2)-175}, tOffset = {x=0,y=12}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2), y=(SSY/2)-300}, tOffset = {x=0,y=12}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
	CosmosOut = {[0] = {tPos = {x=(SSX/2), y=(SSY/2)}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
						[1] = {nTimeToPos = 1000, tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = SSX, y1 = 0, y2 = SSY}},
	CosmosIn = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = SSX, y1 = 0, y2 = SSY}},
						[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2), y=(SSY/2)}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
]]
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function NCT:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
	if self.tSavedData == nil then
		self.tSavedData = {}
		self.tSavedData.tContPos = {}
		local SSX, SSY = Apollo.GetScreenSize()
		self.tSavedData.tDD = {nCont = 0, nATime = .1, strStyle = "FromLeftOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strCCol = "ffffff00", strSCol = "ff00beff", strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strVCol = "ffff00ff", strVCCol = "ff00ffff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tDR = {nCont = 0, nATime = .1, strStyle = "FromRightOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffaa0000", strCCol = "ffff0000",  strSCol = "ff00beff",  strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strVCol = "ffff00aa", strVCCol = "ffaaffff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		--self.tSavedData.tDD = {nCont = 0, tStyle = {[0] = {tPosStart = {x=(SSX/2)-100, y=SSY/2,}, tPosEnd = {0,0}, nTimeToPos = 1000, tOffset = {0,0}, tRandStart = {0,0}, tRandEnd = {x1 = 0, x2 = (SSX/2)-100), y1 = 0, y2 = SSY,}, strCol = "ffffffff", strCCol = "ffffff00", strSCol = "ff00beff", strSCCol = "ff0044ff", strACol = "ffff7700", strACCol = "ffff4400", strVCol = "ffff00ff", strVCCol = "ffaa00ff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		--self.tSavedData.tDR = {nCont = 0, tStyle = {[0] = {tPosStart = {}, tPosEnd = {}, nTimeToPos = 1000, tOffset = {},}, strCol = "ffaa0000", strCCol = "ffff0000",  strSCol = "ff00beff",  strSCCol = "ff0044ff", strACol = "ffff7700", strACCol = "ffff4400", strVCol = "ffff00aa", strVCCol = "ffaaffff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tHD = {nCont = 0, nATime = .1, strStyle = "FromLeftOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ff00ff00", strCCol = "ff005500",  strSCol = "ff00beff",  strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strTCol = "ffff00aa", strTCCol = "ffaaffff", strFont = "CRB_FloaterSmall",  strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strTFont = "CRB_FloaterSmall", strTCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tHR = {nCont = 0, nATime = .1, strStyle = "FromRightOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ff00ff00", strCCol = "ff005500",  strSCol = "ff00beff",  strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strTCol = "ffff00aa", strTCCol = "ffaaffff", strFont = "CRB_FloaterSmall",  strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tPD = {nCont = 0, nATime = .1, strStyle = "FromLeftOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strCCol = "ffffff00", strSCol = "ff00beff", strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strVCol = "ffff00ff", strVCCol = "ff00ffff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tPR = {nCont = 0, nATime = .1, strStyle = "FromRightOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffaa0000", strCCol = "ffff0000",  strSCol = "ff00beff",  strSCCol = "ff0044ff", strACol = "ffbbbb00", strACCol = "ffffbb00", strVCol = "ffff00aa", strVCCol = "ffaaffff", strFont = "CRB_FloaterSmall", strCFont = "CRB_FloaterSmall", strSFont = "CRB_FloaterSmall", strSCFont = "CRB_FloaterSmall", strAFont = "CRB_FloaterSmall", strACFont = "CRB_FloaterSmall", strVFont = "CRB_FloaterSmall", strVCFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tID = {nCont = 0, nATime = .1, strStyle = "FromLeftOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShow = true, bSpellName = false,}
		self.tSavedData.tIR = {nCont = 0, nATime = .1, strStyle = "FromRightOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShow = true, bSpellName = false,}
		self.tSavedData.tEP = {nCont = 0, nATime = .1, strStyle = "FromRightOfPlayer", tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strFont = "CRB_FloaterSmall", strRCol = "ffbb33ff", strRFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tRep = {nCont = 2, nATime = .1, strStyle = nil, tPosStart = nil, tPosEnd = nil, strCol = "ffffffff", strFont = "CRB_FloaterSmall", nLimit = 11, bAdd = true, bShorten = true, bShow = true, bSpellName = false,}
		self.tSavedData.tDef = {nCont = 0, nATime = .1, strStyle = "FromLeftOfPlayer", strCol = "ff7777ff", strFont = "CRB_FloaterSmall", nLimit = 11, bShow = true,}
		self.tSavedData.tSty = {["FromLeftOfPlayer"] = {[0] = {tPos = {x=(SSX/2)-100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=0,y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = (SSX/2)-100, y1 = 0, y2 = SSY,}}},
								["FromRightOfPlayer"] = {[0] = {tPos = {x=(SSX/2)+100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}, 
													[1] = {nTimeToPos = 1000, tPos = {x=0,y=0}, tOffset = {x=0,y=0}, tRand = {x1 = (SSX/2)+100, x2 = SSX, y1 = 0, y2 = SSY,}}},
								["ToLeftOfPlayer"] = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = (SSX/2)-100, y1 = 0, y2 = SSY}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["ToRightOfPlayer"] = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = (SSX/2)+100, x2 = SSX, y1 = 0, y2 = SSY}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)+100, y=SSY/2}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["Not Sauce's DD"] = {[0] = {tPos = {x=(SSX/2)-300, y=(SSY/2)+75}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-350, y=(SSY/2)+175}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["Sauce's DD"] = {[0] = {tPos = {x=(SSX/2)-150, y=(SSY/2)-50}, tOffset = {x=0,y=15}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)-200, y=(SSY/2)-400}, tOffset = {x=0,y=15}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["Sauce's DR"] = {[0] = {tPos = {x=(SSX/2)+200, y=(SSY/2)+75}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2)+250, y=(SSY/2)+175}, tOffset = {x=0,y=-18}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["Sauce's ID"] = {[0] = {tPos = {x=(SSX/2), y=(SSY/2)-175}, tOffset = {x=0,y=12}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2), y=(SSY/2)-300}, tOffset = {x=0,y=12}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								["CosmosOut"] = {[0] = {tPos = {x=(SSX/2), y=(SSY/2)}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}},
													[1] = {nTimeToPos = 1000, tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = SSX, y1 = 0, y2 = SSY}}},
								["CosmosIn"] = {[0] = {tPos = {x=0, y=0}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = SSX, y1 = 0, y2 = SSY}},
													[1] = {nTimeToPos = 1000, tPos = {x=(SSX/2), y=(SSY/2)}, tOffset = {x=0,y=0}, tRand = {x1 = 0, x2 = 0, y1 = 0, y2 = 0}}},
								}
	end
    return o
end

function NCT:Init()
    local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 
-----------------------------------------------------------------------------------------------
-- NCT OnLoad
-----------------------------------------------------------------------------------------------
function NCT:OnLoad()
	Apollo.LoadSprites("Sprites.xml", "Sprites")
	self.xmlDoc = XmlDoc.CreateFromFile("NCT.xml")
	self.wndMain = Apollo.LoadForm(self.xmlDoc, "NCTForm", "FixedHUDStratum", self)
	self.tConts = {[0] = nil, [1] = nil, [2] = nil}
	self.tCT = {[0] = {}, [1] = {}, [2] = {}}
	self.strCCfg = "Damage Done"
	self.strLoc = "eng"
	self.tBuffs = {}
	self.tDebuffs = {}
	self.nTQ = {["SDR"] = 0, ["SDD"] = 0, ["SID"] = 0, ["NSDD"] = 0,}
	--self:CreateContainer(1, nil)
	--self:CreateContainer(2, nil)
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	--self.fakeInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
end

-----------------------------------------------------------------------------------------------
-- NCT OnDocLoaded
-----------------------------------------------------------------------------------------------
function NCT:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded()then
		self:Initialize()
	end
end
-----------------------------------------------------------------------------------------------
-- NCT Functions
-----------------------------------------------------------------------------------------------

function NCT:Initialize()
	Apollo.RegisterEventHandler("CombatLogDamage", 				"OnNCTDamage", self)
	Apollo.RegisterEventHandler("CombatLogHeal", 				"OnNCTHeal", self)
	Apollo.RegisterEventHandler("CombatLogTransference",		"OnNCTTransfer", self)
	Apollo.RegisterEventHandler("CombatLogCCState",				"OnNCTCCState", self)
	Apollo.RegisterEventHandler("CombatLogCCStateBreak",		"OnNCTCCStateBreak", self)
	Apollo.RegisterEventHandler("CombatLogModifyInterruptArmor","OnNCTModifyInterruptArmor", self)
	Apollo.RegisterEventHandler("CombatMomentum",				"OnNCTMomentum", self)
	Apollo.RegisterEventHandler("UnitEvaded",					"OnNCTEvade", self)
	Apollo.RegisterEventHandler("ExperienceGained",				"OnNCTExp", self)
	Apollo.RegisterEventHandler("AttackMissed",					"OnMiss", self)
	Apollo.RegisterTimerHandler("NCT_RandomTimer",				"OnTimer", self)
	Apollo.RegisterSlashCommand("nctdndon",						"OnSlashCommandOn", self)
	Apollo.RegisterSlashCommand("nctdndoff",					"OnSlashCommandOff", self)
	Apollo.RegisterSlashCommand("nct",							"OnSlashCommand", self)
	Apollo.RegisterEventHandler("ConfigWindow_BtnReq_NCT",		"OnConfigReq", self)
	Apollo.RegisterEventHandler("ConfigWindow_CfgUpd_NCT",		"OnCfgBtnUpd", self)
	
	Apollo.CreateTimer("NCT_RandomTimer", .1, true)
	Event_FireGenericEvent("ConfigWindow_InitRep", {name = "NCT"})
	if Apollo.GetAddon("FloatText") then
		setmetatable(Apollo.GetAddon("FloatText"), nil)
	end
end

function NCT:OnSlashCommand()
	Event_FireGenericEvent("ConfigWindow_DemReq", {name = "NCT"})
end

function NCT:OnConfigReq()
	self:CfgEventHelper()
end

function NCT:CfgEventHelper()
	local tFontList = Apollo.GetGameFonts()
	for i, v in pairs(tFontList) do
		tFontList[i] = v.name
	end
	local tLoc = {
		["eng"] = {
			["Damage Done"] = "tDD",
			["Damage Received"] = "tDR",
			["Healing Done"] = "tHD",
			["Healing Received"] = "tHR",
			["Pet Done"] = "tPD",
			["Pet Received"] = "tPR",
			["Interrupt Done"] = "tID",
			["Interrupt Received"] = "tIR",
			["Experience"] = "tEP",
			["Reputation"] = "tRep",
			["Default"] = "tDef",
		},
	}
	local sLoc = tLoc[self.strLoc][self.strCCfg]
	local tConfig = {}
	tConfig[1] = {type = "drop down", val = self.strCCfg, text = "Type", grid = {"Damage Done", "Damage Received", "Healing Done", "Healing Received", "Interrupt Done", "Interrupt Received", "Pet Done", "Pet Received", "Experience", "Reputation", "Default"}, var = "DDType",}
	if sLoc ~= "tRep" then
		tConfig[2] = {type = "radial", val = self.tSavedData[sLoc].bShow, text = "Show "..self.strCCfg, var = "bShow", owner = sLoc,}
		tConfig[3] = {type = "radial", val = self.tSavedData[sLoc].bAdd, text = "Merge Texts", var = "bAdd", owner = sLoc,}
		tConfig[4] = {type = "edit line", val = self.tSavedData[sLoc].nATime, text = "Merge Delay", var = "nATime", owner = sLoc,}
		tConfig[5] = {type = "edit line", val = self.tSavedData[sLoc].nCont, text = "Container", var = "nCont", owner = sLoc,}
		tConfig[6] = {type = "drop down", val = self.tSavedData[sLoc].strStyle, text = "Style", grid = {"ToLeftOfPlayer", "ToRightOfPlayer", "FromLeftOfPlayer", "FromRightOfPlayer", "CosmosIn", "CosmosOut", "Not Sauce's DD", "Sauce's DD", "Sauce's DR", "Sauce's ID",}, var = "strStyle", owner = sLoc,}
		tConfig[9] = {type = "divider",}
		tConfig[10] = {type = "header", text = "Normal",}
		tConfig[11] = {type = "color", val = self.tSavedData[sLoc].strCol, text = "Text Color", var = "strCol", owner = sLoc,}
		tConfig[12] = {type = "drop down", val = self.tSavedData[sLoc].strFont, text = "Font Type", grid = tFontList, var = "strFont", owner = sLoc,}
		if sLoc == "tEP" then
			tConfig[13] = {type = "header", text = "Rested",}
			tConfig[14] = {type = "color", val = self.tSavedData[sLoc].strRCol, text = "Text Color", var = "strRCol", owner = sLoc,}
			tConfig[15] = {type = "drop down", val = self.tSavedData[sLoc].strRFont, text = "Font Type", grid = tFontList, var = "strRFont", owner = sLoc,}
			tConfig[7] = {type = "radial", val = self.tSavedData[sLoc].bShorten, text = "Shorten Numbers", var = "bShorten", owner = sLoc,}
		end
		if sLoc ~= "tDef" and sLoc ~= "tEP" then
			tConfig[8] = {type = "radial", val = self.tSavedData[sLoc].bSpellName, text = "Spell Names", var = "bSpellName", owner = sLoc,}
			if sLoc ~= "tID" and sLoc ~= "tIR" then
				tConfig[7] = {type = "radial", val = self.tSavedData[sLoc].bShorten, text = "Shorten Numbers", var = "bShorten", owner = sLoc,}
				tConfig[13] = {type = "divider",}
				tConfig[14] = {type = "header", text = "Critical",}
				tConfig[15] = {type = "color", val = self.tSavedData[sLoc].strCCol, text = "Text Color", var = "strCCol", owner = sLoc,}
				tConfig[16] = {type = "drop down", val = self.tSavedData[sLoc].strCFont, text = "Font Type", grid = tFontList, var = "strCFont", owner = sLoc,}
				tConfig[17] = {type = "divider",}
				tConfig[18] = {type = "header", text = "Shield",}
				tConfig[19] = {type = "color", val = self.tSavedData[sLoc].strSCol, text = "Text Color", var = "strSCol", owner = sLoc,}
				tConfig[20] = {type = "drop down", val = self.tSavedData[sLoc].strSFont, text = "Font Type", grid = tFontList, var = "strSFont", owner = sLoc,}
				tConfig[21] = {type = "divider",}
				tConfig[22] = {type = "header", text = "Shield Critical",}
				tConfig[23] = {type = "color", val = self.tSavedData[sLoc].strSCCol, text = "Text Color", var = "strSCCol", owner = sLoc,}
				tConfig[24] = {type = "drop down", val = self.tSavedData[sLoc].strSCFont, text = "Font Type", grid = tFontList, var = "strSCFont", owner = sLoc,}
				tConfig[25] = {type = "divider",}
				tConfig[26] = {type = "header", text = "Absorb",}
				tConfig[27] = {type = "color", val = self.tSavedData[sLoc].strACol, text = "Text Color", var = "strACol", owner = sLoc,}
				tConfig[28] = {type = "drop down", val = self.tSavedData[sLoc].strAFont, text = "Font Type", grid = tFontList, var = "strAFont", owner = sLoc,}
				tConfig[29] = {type = "divider",}
				tConfig[30] = {type = "header", text = "Absorb Critical",}
				tConfig[31] = {type = "color", val = self.tSavedData[sLoc].strACCol, text = "Text Color", var = "strACCol", owner = sLoc,}
				tConfig[32] = {type = "drop down", val = self.tSavedData[sLoc].strACFont, text = "Font Type", grid = tFontList, var = "strACFont", owner = sLoc,}
				if sLoc ~= "tHD" and sLoc ~= "tHR" then
					tConfig[33] = {type = "divider",}
					tConfig[34] = {type = "header", text = "Vulnerable",}
					tConfig[35] = {type = "color", val = self.tSavedData[sLoc].strVCol, text = "Text Color", var = "strVCol", owner = sLoc,}
					tConfig[36] = {type = "drop down", val = self.tSavedData[sLoc].strVFont, text = "Font Type", grid = tFontList, var = "strVFont", owner = sLoc,}
					tConfig[37] = {type = "divider",}
					tConfig[38] = {type = "header", text = "Vulnerable Critical",}
					tConfig[39] = {type = "color", val = self.tSavedData[sLoc].strVCCol, text = "Text Color", var = "strVCCol", owner = sLoc,}
					tConfig[40] = {type = "drop down", val = self.tSavedData[sLoc].strVCFont, text = "Font Type", grid = tFontList, var = "strVCFont", owner = sLoc,}
				end
			end
		end
	end
	Event_FireGenericEvent("ConfigWindow_BtnRes", tConfig)
end

function NCT:OnCfgBtnUpd(p)
	if p.var == "DDType" then
		self.strCCfg = p.val
		self:CfgEventHelper()
	elseif string.find(p.var, "Col") then
		local strColor = string.format("%02x%02x%02x%02x", math.floor(p.val.a * 255), math.floor(p.val.r * 255), math.floor(p.val.g * 255), math.floor(p.val.b * 255))
		self.tSavedData[p.owner][p.var] = strColor
	elseif p.var == "nCont" and tonumber(p.val) then
		if self.tConts[tonumber(p.val)] == nil then
			self:CreateContainer(tonumber(p.val), nil)
			self.tCT[tonumber(p.val)] = {}
		end
		self.tSavedData[p.owner][p.var] = tonumber(p.val)
	else
		self.tSavedData[p.owner][p.var] = p.val
	end
end
	
function NCT:CreateContainer(ind, anchor)
	self.tConts[ind] = Apollo.LoadForm(self.xmlDoc, "Container", self.wndMain, self)
	if anchor and type(anchor) == "table" then
		self.tConts[ind]:SetAnchorOffsets(unpack(anchor))
	end
	self.tConts[ind]:Show(true)
end

function NCT:OnSlashCommandOn()
	for i, v in pairs(self.tConts) do	
		v:SetStyle("Moveable", true)
		v:SetText(i)
	end
end

function NCT:OnSlashCommandOff()
	for i, v in pairs(self.tConts) do
		v:SetStyle("Moveable", false)
		v:SetText("")
	end
end

function NCT:ShortenNumber(number)
	if number >= 1e12 then return string.format("%.1f", number / 1e12) .. "T" end
	if number >= 1e9 then return string.format("%.1f", number / 1e9) .. "B" end
	if number >= 1e6 then return string.format("%.1f", number / 1e6) .. "M" end
	if number >= 1000 then return string.format("%.1f", number / 1000) .. "K" end
	return number
end	
	

function NCT:msgFormatter(p, tCheck, nHealth, nShield, nAbsorb, nOverheal)
	local msg = ""
	if tCheck.bSpellName then
		if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
			msg = msg .. "<T Font=\""..tCheck.strCFont.."\"><T TextColor=\"".. tCheck.strCCol .."\">" .. p.splCallingSpell:GetName() .. " </T></T>"
		else
			msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">" .. p.splCallingSpell:GetName() .. " </T></T>"
		end
	end
	if nHealth and nHealth > 0 then
		if tCheck.bShorten then
			nHealth = self:ShortenNumber(nHealth)
		end
		if p.eEffectType ~= 118 and p.eEffectType ~= 10 then
			if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical and p.bTargetVulnerable then
				msg = msg .. "<T Font=\""..tCheck.strVCFont.."\"><T TextColor=\"".. tCheck.strVCCol .."\">" .. nHealth .. "</T></T>"
			elseif p.eCombatResult == GameLib.CodeEnumCombatResult.Critical and p.bTransference then
				msg = msg .. "<T Font=\""..tCheck.strTCFont.."\"><T TextColor=\"".. tCheck.strTCCol .."\">\<" .. nHealth .. "\></T></T>"
			elseif p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
				msg = msg .. "<T Font=\""..tCheck.strCFont.."\"><T TextColor=\"".. tCheck.strCCol .."\">" .. nHealth .. "</T></T>"
			elseif p.bTargetVulnerable then
				msg = msg .. "<T Font=\""..tCheck.strVFont.."\"><T TextColor=\"".. tCheck.strVCol .."\">" .. nHealth .. "</T></T>"
			--[[elseif p.bTransference then
				msg = msg .. "<T Font=\""..tCheck.strTFont.."\"><T TextColor=\"".. tCheck.strTCol .."\">\<" .. nHealth .. "\></T></T>"
]]			else
				msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">" .. nHealth .. "</T></T>"
			end
		elseif p.eEffectType == 118 then
			if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
				msg = msg .. "<T Font=\""..tCheck.strSCFont.."\"><T TextColor=\"".. tCheck.strSCCol .."\">" .. nHealth .. "</T></T>"
			else
				msg = msg .. "<T Font=\""..tCheck.strSFont.."\"><T TextColor=\"".. tCheck.strSCol .."\">" .. nHealth .. "</T></T>"
			end
		else
			if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
				msg = msg .. "<T Font=\""..tCheck.strCFont.."\"><T TextColor=\"".. tCheck.strCCol .."\">" .. nHealth .. "</T></T>"
			else
				msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">" .. nHealth .. "</T></T>"
			end
		end
	end
	if nShield and nShield > 0 then
		if tCheck.bShorten then
			nShield = self:ShortenNumber(nShield)
		end
		if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
			msg = msg .. "<T Font=\""..tCheck.strSCFont.."\"><T TextColor=\"".. tCheck.strSCCol .."\">(" .. nShield .. ")</T></T>"
		else
			msg = msg .. "<T Font=\""..tCheck.strSFont.."\"><T TextColor=\"".. tCheck.strSCol .."\">(" .. nShield .. ")</T></T>"
		end
	end
	if nAbsorb and nAbsorb > 0 then
		if tCheck.bShorten then
			nAbsorb = self:ShortenNumber(nAbsorb)
		end
		if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
			msg = msg .. "<T Font=\""..tCheck.strACFont.."\"><T TextColor=\"".. tCheck.strACCol .."\">~" .. nAbsorb .. "~</T></T>"
		else
			msg = msg .. "<T Font=\""..tCheck.strAFont.."\"><T TextColor=\"".. tCheck.strACol .."\">~" .. nAbsorb .. "~</T></T>"
		end
	end
	if nOverheal and nOverheal > 0 then
		if tCheck.bShorten then
			nOverheal = self:ShortenNumber(nOverheal)
		end
		if p.eEffectType == 118 then
			if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
				msg = msg .. "<T Font=\""..tCheck.strSCFont.."\"><T TextColor=\"".. tCheck.strSCCol .."\">^" .. nOverheal .. "^</T></T>"
			else
				msg = msg .. "<T Font=\""..tCheck.strSFont.."\"><T TextColor=\"".. tCheck.strSCol .."\">^" .. nOverheal .. "^</T></T>"
			end
		else
			if p.eCombatResult == GameLib.CodeEnumCombatResult.Critical then
				msg = msg .. "<T Font=\""..tCheck.strCFont.."\"><T TextColor=\"".. tCheck.strCCol .."\">^" .. nOverheal .. "^</T></T>"
			elseif p.eCombatResult == GameLib.CodeEnumCombatResult.Critical and p.bTransference then
				msg = msg .. "<T Font=\""..tCheck.strTCFont.."\"><T TextColor=\"".. tCheck.strTCCol .."\">\<^" .. nHealth .. "^\></T></T>"
			elseif p.bTransference then
				msg = msg .. "<T Font=\""..tCheck.strTFont.."\"><T TextColor=\"".. tCheck.strTCol .."\">\<^" .. nHealth .. "^\></T></T>"
			else
				msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">^" .. nOverheal .. "^</T></T>"
			end
		end
	end
	return msg
end

function NCT:CTExistsCheck(tContainer, uSpell, tCheck, bHeal)
	for i, v in pairs(tContainer) do
		if v.Spell == uSpell and (v.fader > tonumber(tCheck.nATime)) and v.bHoD == bHeal then
			existsAlready = i
			return existsAlready
		end
	end
	return 0
end

function NCT:CTDoesExist(p, tCheck, tField)
	local msg = ""
	if p.nAbsorption and p.nAbsorption > 0 and tField.Absorb then
		tField.Absorb = tField.Absorb + p.nAbsorption
	elseif p.nAbsorption and p.nAbsorption > 0 then
		tField.Absorb = p.nAbsorption
	end
	if p.nShield and p.nShield > 0 and tField.Shield then
		tField.Shield = tField.Shield + p.nShield
	elseif p.nShield and p.nShield > 0 then
		tField.Shield = p.nShield
	end
	if p.nDamageAmount and p.nDamageAmount > 0 and tField.Health then
		tField.Health = tField.Health + p.nDamageAmount
	elseif p.nDamageAmount and p.nDamageAmount > 0 then
		tField.Health = p.nDamageAmount
	end
	if p.nHealAmount and p.nHealAmount > 0 and tField.Health then
		tField.Health = tField.Health + p.nHealAmount
	elseif p.nHealAmount and p.nHealAmount > 0 then
		tField.Health = p.nHealAmount
	end
	if p.nOverheal and p.nOverheal > 0 and tField.Overheal then
		tField.Overheal = tField.Overheal + p.nOverheal
	elseif p.nOverheal and p.nOverheal > 0 then
		tField.Overheal = p.nOverheal
	end
	msg = self:msgFormatter(p, tCheck, tField.Health, tField.Shield, tField.Absorb, tField.Overheal)
	tField.updates = tField.updates + 1
	if tCheck.nCont ~= 0 then
		tField.fader = 1
		tField.widget:SetOpacity(1)
	end
	tField.widget:SetAML(msg .. " +" .. tField.updates)
end

function NCT:CTNotExist(p, tCheck, newInner, bHeal)
	local strIcon = p.splCallingSpell:GetIcon()
	local strName = p.splCallingSpell:GetName()
	local msg = self:msgFormatter(p, tCheck, (p.nDamageAmount and p.nDamageAmount or p.nHealAmount), p.nShield, p.nAbsorption, p.nOverheal)
	newInner:SetAML(msg)
	if strIcon == "" or strIcon == nil or strName == "Fissure" then
		strIcon = self:CorrectIcon(strName)
	end
	--Print(p.splCallingSpell:GetName().." "..tostring(p.splCallingSpell:GetIcon()))
	newInner:FindChild("S"):SetSprite(strIcon)
	if tCheck.nCont ~= 0 and tCheck.bAdd then
		table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1, Spell = p.splCallingSpell, Absorb = p.nAbsorption, Shield = p.nShield, Health = p.nDamageAmount and p.nDamageAmount or p.nHealAmount, Overheal = p.nOverheal, updates = 0, bHoD = bHeal})
		if self.tCT[tCheck.nCont][tCheck.nLimit] then
			self.tCT[tCheck.nCont][1].widget:Destroy()
			table.remove(self.tCT[tCheck.nCont], 1)
		end
	elseif tCheck.bAdd then
		table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1, Spell = p.splCallingSpell, Absorb = p.nAbsorption, Shield = p.nShield, Health = p.nDamageAmount and p.nDamageAmount or p.nHealAmount, Overheal = p.nOverheal, updates = 0, bHoD = bHeal})
	else
		table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1})
	end
end

function NCT:CTCheck(tCheck, p, bHeal)
	local existsAlready = self:CTExistsCheck(self.tCT[tCheck.nCont], p.splCallingSpell, tCheck, bHeal)
	if existsAlready ~= 0 and tCheck.bAdd then
		self:CTDoesExist(p, tCheck, self.tCT[tCheck.nCont][existsAlready])
	else
		local newInner
		if tCheck.nCont == 0 then
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
		else
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.tConts[tCheck.nCont], self)
		end
		newInner:Show(true)
		self:CTNotExist(p, tCheck, newInner, bHeal)
		if tCheck.nCont == 0 then
			self:RunStyle(newInner, tCheck, p)
		end
	end
	if tCheck.nCont ~= 0 then
		self.tConts[tCheck.nCont]:ArrangeChildrenVert(0)
	end
end

function NCT:RunStyle(wndToSty, tCheck, p)
	local SSX, SSY = Apollo.GetScreenSize()
	local tFP = {0.00214,0.00531,0.99357,0.10806}

	if tCheck.strStyle == "ToLeftOfPlayer" then
		local nRandX = math.random(0, (SSX/2)-100)
		local nRandY = math.random(0, SSY)
		--self.fakeInner:SetAnchorOffsets(nRandX, nRandY, nRandX, nRandY)
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {nRandX, nRandY, nRandX, nRandY}})
		wndToSty:SetAnchorOffsets((SSX/2)-100, SSY/2, (SSX/2)-100, SSY/2)
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
	elseif tCheck.strStyle == "ToRightOfPlayer" then
		local nRandX = math.random((SSX/2)+100, SSX)
		local nRandY = math.random(0, SSY)
		--self.fakeInner:SetAnchorOffsets(nRandX, nRandY, nRandX, nRandY)
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {nRandX, nRandY, nRandX, nRandY}})
		wndToSty:SetAnchorOffsets((SSX/2)+100, SSY/2, (SSX/2)+20, SSY/2)
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
	elseif tCheck.strStyle == "FromLeftOfPlayer" then
		local nRandX = math.random(0, (SSX/2)-100)
		local nRandY = math.random(0, SSY)
		--self.fakeInner:SetAnchorOffsets((SSX/2)-100, SSY/2, (SSX/2)-100, SSY/2)
		--local uLoc = self.fakeInner:GetLocation()
		wndToSty:SetAnchorOffsets(nRandX, nRandY, nRandX, nRandY)
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2)-100, SSY/2, (SSX/2)-100, SSY/2}})
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
	elseif tCheck.strStyle == "FromRightOfPlayer" then
		local nRandX = math.random((SSX/2)+100, SSX)
		local nRandY = math.random(0, SSY)
		--self.fakeInner:SetAnchorOffsets((SSX/2)+100, SSY/2, (SSX/2)+100, SSY/2)
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2)+100, SSY/2, (SSX/2)+100, SSY/2}})
		wndToSty:SetAnchorOffsets(nRandX, nRandY, nRandX, nRandY)
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
	elseif tCheck.strStyle == "Not Sauce's DD" then
		--self.fakeInner:SetAnchorOffsets((SSX/2-300), SSY/2+75 - self.nTQ["NSDD"], (SSX/2)-300, SSY/2+75 - self.nTQ["NSDD"])
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2-300), SSY/2+75 - self.nTQ["NSDD"], (SSX/2)-300, SSY/2+75 - self.nTQ["NSDD"]}})
		wndToSty:SetAnchorOffsets(SSX/2-350, SSY/2+175 - self.nTQ["NSDD"], SSX/2-350, SSY/2+175 - self.nTQ["NSDD"])
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .1)
		self.nTQ["NSDD"] = self.nTQ["NSDD"] + 18
	elseif tCheck.strStyle == "Sauce's DD" then
		--self.fakeInner:SetAnchorOffsets((SSX/2)-150, SSY/2-50 + self.nTQ["SDD"], (SSX/2)-150, SSY/2-50 + self.nTQ["SDD"])
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2)-150, SSY/2-50 + self.nTQ["SDD"], (SSX/2)-150, SSY/2-50 + self.nTQ["SDD"]}})
		wndToSty:SetAnchorOffsets(SSX/2-200, SSY/2-400 + self.nTQ["SDD"], SSX/2-200, SSY/2-400 + self.nTQ["SDD"])
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .3)
		self.nTQ["SDD"] = self.nTQ["SDD"] + 15
	elseif tCheck.strStyle == "Sauce's DR" then
		--self.fakeInner:SetAnchorOffsets((SSX/2+200), SSY/2+75 - self.nTQ["SDR"], (SSX/2)+200, SSY/2+75 - self.nTQ["SDR"])
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2+200), SSY/2+75 - self.nTQ["SDR"], (SSX/2)+200, SSY/2+75 - self.nTQ["SDR"]}})
		wndToSty:SetAnchorOffsets(SSX/2+250, SSY/2+175 - self.nTQ["SDR"], SSX/2+250, SSY/2+175 - self.nTQ["SDR"])
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .1)
		self.nTQ["SDR"] = self.nTQ["SDR"] + 18	
	elseif tCheck.strStyle == "Sauce's ID" then
		--self.fakeInner:SetAnchorOffsets((SSX/2), SSY/2-175 + self.nTQ["SID"], (SSX/2), SSY/2-175 + self.nTQ["SID"])
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {(SSX/2), SSY/2-175 + self.nTQ["SID"], (SSX/2), SSY/2-175 + self.nTQ["SID"]}})
		wndToSty:SetAnchorOffsets(SSX/2, SSY/2-300 + self.nTQ["SID"], SSX/2, SSY/2-300 + self.nTQ["SID"])
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
		self.nTQ["SID"] = self.nTQ["SID"] + 12
	elseif tCheck.strStyle == "CosmosOut" then
		--self.fakeInner:SetAnchorOffsets(SSX/2, SSY/2, SSX/2, SSY/2)
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {SSX/2, SSY/2, SSX/2, SSY/2}})
		wndToSty:SetAnchorOffsets(math.random(0, SSX), math.random(0, SSY), math.random(0, SSX), math.random(0, SSY))
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .2)
	elseif tCheck.strStyle == "CosmosIn" then
		--self.fakeInner:SetAnchorOffsets(math.random(0, SSX), math.random(0, SSY), math.random(0, SSX), math.random(0, SSY))
		--local uLoc = self.fakeInner:GetLocation()
		local tLoc = WindowLocation.new({ fPoints = tFP, nOffsets = {math.random(0, SSX), math.random(0, SSY), math.random(0, SSX), math.random(0, SSY)}})
		wndToSty:SetAnchorOffsets(SSX/2, SSY/2, SSX/2, SSY/2)
		wndToSty:TransitionMoveFrom(tLoc, 0, false, false, .4)
	end
end

function NCT:CheckTables()
	for i, v in pairs(self.nTQ) do
		if v > 0 and i ~= "SDD" then
			self.nTQ[i] = self.nTQ[i] - 1
		elseif v > 0 then
			self.nTQ[i] = self.nTQ[i] - 5
		end
		if v > 500 and i == "SDD" then
			self.nTQ[i] = 0
		elseif v > 200 and i ~= "SDD" and i ~= "SDR" then
			self.nTQ[i] = 0
		elseif v > 120 and i == "SID" then
			self.nTQ[i] = 0
		end
	end
	for j, x in pairs(self.tCT) do
		for i, v in pairs(x) do
			if v.fader > 0 and j == 0 then
				v.widget:SetOpacity(v.fader)
				v.fader = v.fader - .08
				--[[if v.fader < .65 then
					local l, t, r, b = v.widget:GetRect()
						local SSX, SSY = Apollo.GetScreenSize()

					v.widget:SetAnchorOffsets(l+200, t, r+200, b)
					v.widget:TransitionMoveFromFrom(l, t, r, b, 2, false)
				end]]
			elseif v.fader > 0 then
				v.widget:SetOpacity(v.fader)
				v.fader = v.fader - .08
			else
				if v and v.widget then
					v.widget:Destroy()
					v = nil
					table.remove(x, i)
					if j ~= 0 then
						self.tConts[j]:ArrangeChildrenVert(0)
					end
				end
			end
		end
	end
end

function NCT:CorrectIcon(strName)
	local tCorrections = {
	["Impale"] = "IconSprites:Icon_SkillShadow_UI_stlkr_tacticalthrust",
	["Shred"] = "IconSprites:Icon_SkillShadow_UI_SM_rip",
	["Stagger"] = "IconSprites:Icon_SkillShadow_UI_stlkr_staggeringthrust",
	["Analyze Weakness"] = "IconSprites:Icon_SkillStalker_Analyze_Weakness",
	["Razor Disk"] = "IconSprites:Icon_SkillStalker_Razor_Disk",
	["Quick Draw"] = "IconSprites:Icon_SkillSpellslinger_mobile_fire",
	["Assassinate"] = "IconSprites:Icon_SkillSpellslinger_assassinate",
	["Assassin"] = "IconSprites:Icon_CraftingUI_ItemCrafting_Special1_Purple",
	["Impact"] = "IconSprites:Icon_CraftingUI_ItemCrafting_Special1_Purple",
	["Shadow Blast"] = "IconSprites:Icon_CraftingUI_ItemCrafting_Special1_Purple",
	["Rapid Fire"] = "IconSprites:Icon_SkillSpellslinger_rapid_fire",
	["Rapid Dasher"] = "IconSprites:Icon_SkillNature_UI_srcr_wndwlk",
	["Relentless Strikes"] = "IconSprites:Icon_SkillPhysical_UI_wr_lng",
	["Savage Strikes"] = "IconSprites:Icon_SkillPhysical_UI_wr_cntrsrk",
	["Whirlwind"] = "IconSprites:Icon_SkillPhysical_UI_wr_wrlwnd",
	["Breaching Strikes"] = "IconSprites:Icon_SkillPhysical_UI_wr_clv",
	["Augmented Blades"] = "IconSprites:Icon_SkillMisc_UI_m_amplfydmg",
	["Menacing Strike"] = "IconSprites:Icon_SkillWarrior_Guarded_Strikes",
	["Plasma Wall"] = "IconSprites:Icon_SkillWarrior_Plasma_Wall",
	["Bolstering Strike"] = "IconSprites:Icon_SkillMisc_UI_wr_dfgrp",
	["Gamma Rays"] = "ClientSprites:Icon_SkillMedic_gammarays",
	["Fissure"] = "ClientSprites:Icon_SkillMedic_Fissure",
	["Shield Surge"] = "IconSprites:Icon_SkillMedic_sheildsurge",
	}
	
	return tCorrections[strName] or "IconSprites:Icon_SkillSbuff_insightdebuff2"
end
-----------------------------------------------------------------------------------------------
-- NCT Global Functions
-----------------------------------------------------------------------------------------------
function NCT:OnTimer()
	self:CheckTables()
end

function NCT:OnNCTModifyInterruptArmor(p)
	--[[ unitCaster = userdata, unitCasterOwner = userdata/nil, unitTarget = userdata,
	     unitTargetOwner = userdata/nil, nAmount = int,
	
	     PLAYER ONLY EVENT
	]]
end

function NCT:OnNCTCCState(p)
	--[[ eResult = CF.CECCSARR, strState = "Stun"..., splCallingSpell = userdata, eState = U.CECCS,
	     nInterruptArmorHit = amount of IA removed, eCombatResult = GL.CECR, strTriggerCapCategory = category of DR type,
	     unitCaster = userdata, unitTarget = userdata, unitCasterOwner = userdata/nil, unitCasterTarget = userdata/nil,
	     bRemoved = boolean
	]]
	--[[ CF.CECCSARR: Ok = 0, InvalidCCState = 1, NoTargetSpecified = 2, Target_Immune = 3,
	     Target_InfiniteInterruptArmor = 4, Target_InterruptArmorReduced = 5, Target_InterruptArmorBlocked = 6,
	     Stacking_DoesNotStack = 7, Stacking_ShorterDuration = 8, DiminishingReturns_TriggerCap = 9,
	     Hidden... Target_CCStateBroken = 10
	]]
	local unitPlayer = GameLib.GetPlayerUnit()
	local isAvatarDone = p.unitCaster == unitPlayer
	local isAvatarReceived = p.unitTarget == unitPlayer
	local isPetDone = (p.unitCasterOwner and p.unitCasterOwner == unitPlayer) 
	local isPetReceived = (p.unitTargetOwner and p.unitTargetOwner == unitPlayer) 

	local bGo = false
	local tCheck
	local msg = ""
	local tState = {[0] = "+"..p.strState.."+", [1] = "Invalid", [2] = "No Target", [3] = "Immune", [4] = "Infinite IA", [5] = "IA Reduce", [6] = "IA Deflect", [7] = "Does Not Stack", [8] = p.strState .. " DR", [9] = "DR Immune", [10] = "-"..p.strState.."-"}
	if isAvatarDone and self.tSavedData.tID.bShow then
		tCheck = self.tSavedData.tID
		strName = tCheck.bSpellName and p.splCallingSpell:GetName() or ""
		msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">" .. strName .. " " .. tState[p.eResult] .. "</T></T>"
		bGo = true
	elseif isAvatarReceived and self.tSavedData.tID.bShow then
		tCheck = self.tSavedData.tIR
		strName = tCheck.bSpellName and p.splCallingSpell:GetName() or ""
		msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">" .. strName .. " " .. tState[p.eResult] .. "</T></T>"
		bGo = true
	elseif isPetDone and self.tSavedData.tID.bShow then
		tCheck = self.tSavedData.tID
		strName = tCheck.bSpellName and p.splCallingSpell:GetName() or ""
		msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">P: " .. strName .. " " .. tState[p.eResult] .. "</T></T>"
		bGo = true
	elseif isPetReceived and self.tSavedData.tID.bShow then
		tCheck = self.tSavedData.tIR
		strName = tCheck.bSpellName and p.splCallingSpell:GetName() or ""
		msg = msg .. "<T Font=\""..tCheck.strFont.."\"><T TextColor=\"".. tCheck.strCol .."\">P: " .. strName .. " " .. tState[p.eResult] .. "</T></T>"
		bGo = true
	end
	if bGo then
		local newInner
		if tCheck.nCont == 0 then
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
		else
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.tConts[tCheck.nCont], self)
		end
		newInner:Show(true)
		
		local strIcon = p.splCallingSpell:GetIcon()
		local strName = p.splCallingSpell:GetName()
		if strIcon == "" or strIcon == nil or strName == "Fissure" then
			strIcon = self:CorrectIcon(strName)
		end
		newInner:SetAML(msg)
	
		newInner:FindChild("S"):SetSprite(strIcon)
		table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1})
	
		if tCheck.nCont == 0 then
			self:RunStyle(newInner, tCheck, p)
		end
		
	end
end

function NCT:OnNCTCCStateBreak(p)
	--[[ unitCaster = userdata, unitCasterOwner = userdata,
	     eState = U.CECCS, strState = "Stun"...,
	
	     PLAYER ONLY EVENT
	]]  
	--[[for i, v in pairs(p) do
		Print("CCBreak " ..i.." "..tostring(v))
	end]]
end

function NCT:OnMiss(uC, uT, sT)
	local unitPlayer = GameLib.GetPlayerUnit()
	local isAvatarDone = uC == unitPlayer
	local isAvatarReceived = uT == unitPlayer
	local tCheck = nil
	if isAvatarDone and self.tSavedData.tDD.bShow then
		tCheck = self.tSavedData.tDD
	elseif isAvatarReceived and self.tSavedData.tDR.bShow then
		tCheck = self.tSavedData.tDR
	end
	if tCheck ~= nil then
		if sT == 0 then sT = "Deflect"
		else sT = "Block"
		end
		local msg = "<T Font=\"" .. tCheck.strFont .. "\"><T TextColor=\"" .. tCheck.strCol .. "\">" .. sT .. "</T></T>"
		self:OnNCTDefault(msg, tCheck, "")
	end
end

function NCT:OnNCTDamage(p)
	--[[ bTargetKilled = bool, nOverkill = int, eEffectType = tons of Enum,
		 splCallingSpell = userdata, nDamageAmount = int (health), bPeriodic = bool,
		 unitCaster = userdata, nShield = int (shield), nRawDamage = int (unmit),
		 eDamageType = Enum, nAbsorption = int (absorb), bTargetVulnerable = bool,
		 unitTarget = userdata, eCombatResult = GL.CECR
	]]
	local unitPlayer = GameLib.GetPlayerUnit()
	local isAvatarDone = p.unitCaster == unitPlayer
	local isAvatarReceived = p.unitTarget == unitPlayer
	local isPetDone = (p.unitCasterOwner and p.unitCasterOwner == unitPlayer) 
	local isPetReceived = (p.unitTargetOwner and p.unitTargetOwner == unitPlayer) 
	if isAvatarDone and self.tSavedData.tDD.bShow then
		self:CTCheck(self.tSavedData.tDD, p, false)
	elseif isPetDone and self.tSavedData.tPD.bShow then
		self:CTCheck(self.tSavedData.tPD, p, false)
	elseif isPetReceived and self.tSavedData.tPR.bShow then
		self:CTCheck(self.tSavedData.tPR, p, false)
	elseif isAvatarReceived and self.tSavedData.tDR.bShow then
		self:CTCheck(self.tSavedData.tDR, p, false)
	end
end

function NCT:OnNCTHeal(p)
	--[[ eEffectType = S.CESET, nOverheal = int, nHealAmount = int, eCombatResult = GL.CECR,
	     splCallingSpell = userdata, unitCaster = userdata, unitTarget = userdata,
	     unitCasterOwner = userdata/nil, unitTargetOwner = userdata/nil
	]]
	local unitPlayer = GameLib.GetPlayerUnit()
	local isAvatarDone = p.unitCaster == unitPlayer
	local isAvatarReceived = p.unitTarget == unitPlayer
	local isPetDone = (p.unitCasterOwner and p.unitCasterOwner == unitPlayer) 
	local isPetReceived = (p.unitTargetOwner and p.unitTargetOwner == unitPlayer) 
	if (isAvatarDone or isPetDone) and self.tSavedData.tHD.bShow then
		self:CTCheck(self.tSavedData.tHD, p, true)
	elseif (isAvatarReceived or isPetReceived) and self.tSavedData.tHR.bShow then
		self:CTCheck(self.tSavedData.tHR, p, true)
	end
end

function NCT:OnNCTTransfer(p)
	self:OnNCTDamage(p)
	if p.tHealData then
		for i, v in pairs(p.tHealData) do
			p.bTargetVulnerable = false
			if v.unitHealed == GameLib.GetPlayerUnit() then
			else p.bTransference = true
			end
			p.nDamageAmount = 0
			p.nShield = 0
			p.nAbsorption = 0
			p.unitCaster = p.unitTarget
			p.unitTarget = v.unitHealed
			p.nHealAmount = v.nHealAmount
			p.nOverheal = v.nOverheal
			self:OnNCTHeal(p)
		end
	end
end

function NCT:OnNCTDefault(msg, tCheck, strIcon)
	if tCheck.bShow then
		local newInner
		if tCheck.nCont == 0 then
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
		else
			newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.tConts[tCheck.nCont], self)
		end
		newInner:SetAML(msg)
		newInner:FindChild("S"):SetSprite(strIcon)
		newInner:Show(true)
		p = {}
		p.unitTarget = GameLib.GetPlayerUnit()
		if tCheck.nCont == 0 then
			self:RunStyle(newInner, tCheck, p)
		end
		table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1})
	end
end

function NCT:OnNCTEP(nA, nR)
	local tCheck = self.tSavedData.tEP
	if tCheck.bShow then
		local existsAlready
		for i, v in pairs(self.tCT[tCheck.nCont]) do
			if tCheck.bAdd and v.bExp and v.fader > tCheck.nATime then
				existsAlready = v
			end
		end
		if existsAlready then
			existsAlready.nRExp = existsAlready.nRExp + nR
			existsAlready.nExp = existsAlready.nExp + nA
			existsAlready.nUpdates = existsAlready.nUpdates + 1
			local nE, nRE = existsAlready.nExp, existsAlready.nRExp
			if tCheck.bShorten then
				nE = self:ShortenNumber(existsAlready.nExp)
				nRE = self:ShortenNumber(existsAlready.nRExp)
			end
			local msg = "<T Font=\"" .. self.tSavedData.tEP.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strCol .. "\">+" .. nE .. "</T></T>"
			if existsAlready.nRExp > 0 then
				msg = msg .. "<T Font=\"" .. self.tSavedData.tEP.strRFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strRCol .. "\"> (" .. nRE .. ")</T></T>"
			end
			if existsAlready.nUpdates > 0 then
				msg = msg .. " +" .. existsAlready.nUpdates
			end
			existsAlready.widget:SetAML(msg)
		else
			local nE, nRE = nA, nR
			if tCheck.bShorten then
				nE = self:ShortenNumber(nA)
				nRE = self:ShortenNumber(nR)
			end
			local msg = "<T Font=\"" .. self.tSavedData.tEP.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strCol .. "\">+" .. nE .. "</T></T>"
			if nR > 0 then
				msg = msg .. "<T Font=\"" .. self.tSavedData.tEP.strRFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strRCol .. "\"> (" .. nRE .. ")</T></T>"
			end
			local newInner
			if tCheck.nCont == 0 then
				newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
			else
				newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.tConts[tCheck.nCont], self)
			end
			newInner:SetAML(msg)
			newInner:FindChild("S"):SetSprite(strIcon)
			newInner:Show(true)
			p = {}
			p.unitTarget = GameLib.GetPlayerUnit()
			if tCheck.nCont == 0 then
				self:RunStyle(newInner, tCheck, p)
			end
			table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1, nUpdates = 0, nExp = nA, nRExp = nR, bExp = true})
		end
	end

end

function NCT:OnNCTExp(eR, uT, sT, fD, nA)
	--self:OnNCTDefault(msg, self.tSavedData.tEP, "IconSprites:Icon_Modifier_xp_001")
	local tCheck = self.tSavedData.tEP
	local bIsRested = eR == CombatFloater.CodeEnumExpReason.Rested
	if tCheck.bShow then
		local existsAlready
		for i, v in pairs(self.tCT[tCheck.nCont]) do
			if (v.bExp and v.bRestAdd == false and bIsRested) or (tCheck.bAdd and v.bExp and v.fader > tCheck.nATime) then
				existsAlready = v
			end
		end
		if existsAlready then
			if bIsRested then
				existsAlready.bRestAdd = true
				existsAlready.nRExp = existsAlready.nRExp + nA
			else
				existsAlready.nExp = existsAlready.nExp + nA
				existsAlready.nUpdates = existsAlready.nUpdates + 1
			end
			local nE, nRE = existsAlready.nExp, existsAlready.nRExp
			if tCheck.bShorten then
				nE = self:ShortenNumber(existsAlready.nExp)
				nRE = self:ShortenNumber(existsAlready.nRExp)
			end
			local msg = "<T Font=\"" .. self.tSavedData.tEP.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strCol .. "\">+" .. nE .. "</T></T>"
			if existsAlready.nRExp > 0 then
				msg = msg .. "<T Font=\"" .. self.tSavedData.tEP.strRFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strRCol .. "\"> (" .. nRE .. ")</T></T>"
			end
			if existsAlready.nUpdates > 0 then
				msg = msg .. " +" .. existsAlready.nUpdates
			end
			existsAlready.widget:SetAML(msg)
		else
			local nE = nA
			if tCheck.bShorten then
				nE = self:ShortenNumber(nA)
			end
			local msg = "<T Font=\"" .. self.tSavedData.tEP.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tEP.strCol .. "\">+" .. nE .. "</T></T>"
			local newInner
			if tCheck.nCont == 0 then
				newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.wndMain, self)
			else
				newInner = Apollo.LoadForm(self.xmlDoc, "Inner", self.tConts[tCheck.nCont], self)
			end
			newInner:SetAML(msg)
			newInner:FindChild("S"):SetSprite(strIcon)
			newInner:Show(true)
			p = {}
			p.unitTarget = GameLib.GetPlayerUnit()
			if tCheck.nCont == 0 then
				self:RunStyle(newInner, tCheck, p)
			end
			table.insert(self.tCT[tCheck.nCont], {widget = newInner, fader = 1, nUpdates = 0, nExp = nA, nRExp = 0, bExp = true, bRestAdd = false})
		end
	end

end

function NCT:OnNCTEvade(uS, uT, eR, sM)
	local msg = "<T Font=\"" .. self.tSavedData.tDef.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tDef.strCol .. "\">" .. sM .. "</T></T>"
	self:OnNCTDefault(msg, self.tSavedData.tDef, "")
end

function NCT:OnNCTMomentum(eMT, nC, sT)
	local arMomentumStrings =
	{
		[CombatFloater.CodeEnumCombatMomentum.Impulse] 				= "Impulse",
		[CombatFloater.CodeEnumCombatMomentum.KillingPerformance] 	= "Performance",
		[CombatFloater.CodeEnumCombatMomentum.KillChain] 			= "Chain",
		[CombatFloater.CodeEnumCombatMomentum.Evade] 				= "Dodge",
		[CombatFloater.CodeEnumCombatMomentum.Interrupt] 			= "Interrupt",
		[CombatFloater.CodeEnumCombatMomentum.CCBreak] 				= "Break",
	}
	local msg = "<T Font=\"" .. self.tSavedData.tDef.strFont .. "\"><T TextColor=\"" .. self.tSavedData.tDef.strCol .. "\">" .. sT .. "</T></T>"
	self:OnNCTDefault(msg, self.tSavedData.tDef, "")
end

function NCT:OnSave(eType)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Account then
		return
	end
	local tSavedData1 = self.tSavedData
	for i, v in pairs(self.tConts) do
		if i ~= 0 then
			if v == nil then
				self:CreateContainer(i, v)
			end
			tSavedData1.tContPos[i] = {v:GetAnchorOffsets()}
		end
	end
	return tSavedData1
end

function NCT:OnRestore(eType, tSavedData1)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Account then
		return
	end
	if tSavedData1 ~= nil then
		for i, v in pairs(tSavedData1) do
			for j, x in pairs(v) do
				--if self.tSavedData[i] and self.tSavedData[i][j] then
					self.tSavedData[i][j] = x
				--end
			end
		end
		for i, v in pairs(self.tSavedData.tContPos) do
			self:CreateContainer(i, v)
			if self.tCT[i] == nil then
				self.tCT[i] = {}
			end
		end
	end
end

-----------------------------------------------------------------------------------------------
-- NCT Instance
-----------------------------------------------------------------------------------------------
local NCTInst = NCT:new()
NCTInst:Init()
